//  ************************************************************************************************
//
//  BornAgain: simulate and fit reflection and scattering
//
//! @file      GUI/View/Import/RealDataStackPresenter.cpp
//! @brief     Implements class RealDataStackPresenter
//!
//! @homepage  http://www.bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Jülich GmbH 2018
//! @authors   Scientific Computing Group at MLZ (see CITATION, AUTHORS)
//
//  ************************************************************************************************

#include "GUI/View/Import/RealDataStackPresenter.h"
#include "GUI/View/Import/RealDataPresenter.h"

void RealDataStackPresenter::setItem(QObject* item, QObject* model)
{
    if (!item) {
        hideWidgets();
        return;
    }

    RealDataPresenter* widget = itemWidget(item);

    if (!widget) {
        widget = new RealDataPresenter();
        m_stackedWidget->addWidget(widget);
        m_itemToWidget[item] = widget;
    }

    m_stackedWidget->setCurrentWidget(widget);
    if (widget->isHidden())
        widget->show();

    widget->setModel(model);
    widget->setJobOrRealItem(item);
}

RealDataPresenter* RealDataStackPresenter::itemWidget(QObject* /*item*/)
{
    if (!m_itemToWidget.empty())
        return m_itemToWidget.first();
    return nullptr;
}
